chrome.tabs.onUpdated.addListener(async (tabId, t) => {
  if (t && t.status == "complete") {
    let queryOptions = { active: true, lastFocusedWindow: true };
    let [tab] = await chrome.tabs.query(queryOptions);

    if (tab && tab.url && tab.url.includes(".adjd.gov.ae")) {
      chrome.tabs.sendMessage(tabId, {
        type: "Login",
      });

      setTimeout(() => {
        chrome.tabs.sendMessage(tabId, {
          type: "Logout",
        });

        chrome.tabs.query({}, async function (tabs) {
          for (var i = 0; i < tabs.length; i++) {
            if (tabs[i].url.includes(".adjd.gov.ae")) {
              await chrome.tabs.update(tabs[i].Id, { selected: true });
              chrome.tabs.sendMessage(tabs[i].id, {
                type: "Logout",
              });
            }
          }
        });
      }, 1 * 60 * 1000);
    }
  }
});

chrome.runtime.onMessage.addListener(async function (
  request,
  sender,
  sendResponse
) {
  const getCredentials = async (subDomain) => {
    let data;
    await fetch("https://adjd.prod.wakalaty.com/api/credentials", {
      method: "GET",
      headers: {
        Accept: "application/json",
        "X-DOMAIN": subDomain,
        "EXT-ID": chrome.runtime.id,
      },
    })
      .then((response) => response.json())
      .then(async (response) => {
        data = response;
      });

    return data;
  };

  const deleteSession = async (subDomain) => {
    await fetch("https://adjd.prod.wakalaty.com/api/session", {
      method: "DELETE",
      headers: {
        Accept: "application/json",
        "X-DOMAIN": subDomain,
        "EXT-ID": chrome.runtime.id,
      },
    });

    return;
  };

  if (request.type == "getCredientials") {
    let data = await getCredentials(request.subDomain);
    // let data = {
    //   email: "judicial6@infinity.ae",
    //   password: "ZNsjy54!?",
    // };

    let queryOptions = { active: true, lastFocusedWindow: true };
    let [tab] = await chrome.tabs.query(queryOptions);

    chrome.tabs.sendMessage(tab.id, {
      type: "autoLogin",
      data: data,
    });
  } else if (request.type == "deleteSession") {
    await deleteSession(request.subDomain);
  }
});
