(() => {
  let apiEmail = "";
  let apiPassword = "";
  let apiMessage = "";

  console.log("content script injected");

  chrome.runtime.onMessage.addListener((obj, sender, response) => {
    try {
      const { type, data } = obj;

      if (type == "Login") {
        addLoginButton();
      } else if (type == "autoLogin") {
        apiEmail = data.username;
        apiPassword = data.password;
        apiMessage = data.message;

        if (data.username && data.password) handleAutoLogin();
        else displayMessage();
      } else if (type == "Logout") {
        handleAutoLogout();
      }
    } catch (error) {
      console.log(error);
    }
  });

  const addLoginButton = async () => {
    let loginform = document.querySelector("form");

    if (loginform) {
      let inputEmail = document.getElementById("Username");
      let inputpass = document.getElementById("Password");

      if (!inputEmail) {
        inputEmail = document.getElementById("s_swepi_1");
        inputpass = document.getElementById("s_swepi_2");
      }

      inputEmail.value = "";
      inputpass.value = "";
    }

    const loginBtnExists = document.getElementsByClassName("auto-login-btn")[0];

    if (!loginBtnExists) {
      const loginDiv = document.createElement("div");
      loginDiv.className = "col-md-12";
      loginDiv.style.display = "flex";
      loginDiv.style.justifyContent = "center";
      loginDiv.style.cursor = "pointer";

      const loginBtn = document.createElement("img");
      loginBtn.src = chrome.runtime.getURL("assets/login.png");
      loginBtn.className = "auto-login-btn";
      loginBtn.style.height = "48px";
      loginBtn.title = "Click to auto login";

      loginDiv.appendChild(loginBtn);

      let loginform = document.querySelector("form");

      if (loginform) {
        loginform.appendChild(loginDiv);
        loginBtn.addEventListener("click", getData);
      }
    }
  };

  const displayMessage = async () => {
    let loginform = document.querySelector("form");

    if (loginform) {
      const MessageExists =
        document.getElementsByClassName("auto-login-msg")[0];

      if (!MessageExists) {
        const loginMsg = document.createElement("p");
        loginMsg.innerText = apiMessage;
        loginMsg.className = "auto-login-msg";
        loginMsg.style.color = "red";
        loginMsg.style.textAlign = "center";

        loginform.appendChild(loginMsg);
      } else {
        MessageExists.innerText = apiMessage;
      }
    }
  };

  const getData = () => {
    chrome.runtime.sendMessage({
      type: "getCredientials",
      subDomain: getSubDomain(),
    });
  };

  const handleAutoLogin = async () => {
    hideForm();

    let loginform = document.querySelector("form");

    if (loginform) {
      let inputEmail = document.getElementById("Username");
      let inputpass = document.getElementById("Password");
      let buttonLogin = document.getElementById("btn-submit");

      if (!inputEmail) {
        inputEmail = document.getElementById("s_swepi_1");
        inputpass = document.getElementById("s_swepi_2");
        buttonLogin = document.getElementById("s_swepi_22");
      }

      inputEmail.value = apiEmail;
      inputpass.value = apiPassword;
      buttonLogin.click();
    }
  };

  const hideForm = () => {
    let loginform = document.querySelector("form");

    const loginBackground = document.createElement("div");

    loginBackground.style.position = "absolute";
    loginBackground.style.display = "flex";
    loginBackground.style.justifyContent = "center";
    loginBackground.style.alignItems = "center";
    loginBackground.style.width = "100%";
    loginBackground.style.height = "100%";
    loginBackground.style.backgroundColor = "white";
    loginBackground.style.top = 0;
    loginBackground.style.left = 0;
    loginBackground.style.zIndex = 10000;

    const img = document.createElement("img");

    img.src = chrome.runtime.getURL("assets/loader.svg");

    loginBackground.appendChild(img);

    if (loginform) {
      loginform.appendChild(loginBackground);
    }
  };

  const handleAutoLogout = () => {
    let logoutButton = document.querySelector("#ui-id-31");

    if (!logoutButton) logoutButton = document.querySelector("#logOut");

    if (logoutButton) {
      logoutButton.click();
    }
    deleteSession();
  };

  const addLogoutListenerOnLoad = () => {
    let logoutButton = document.querySelector("#ui-id-31");

    if (!logoutButton) logoutButton = document.querySelector("#logOut");

    if (logoutButton) logoutButton.addEventListener("click", deleteSession);
  };

  const deleteSession = () => {
    deleteCookies();

    chrome.runtime.sendMessage({
      type: "deleteSession",
      subDomain: getSubDomain(),
    });
  };

  const deleteCookies = () => {
    var allCookies = document.cookie.split(";");

    // The "expire" attribute of every cookie is
    // Set to "Thu, 01 Jan 1970 00:00:00 GMT"
    for (var i = 0; i < allCookies.length; i++)
      document.cookie =
        allCookies[i] + "=;expires=" + new Date(0).toUTCString();
  };

  const getSubDomain = () => {
    let href = window.location.href;
    href = href.split(".")[0];
    href = href.split("//")[1];
    return href;
  };

  addLogoutListenerOnLoad();
})();
